package mailinglist.client;

import java.io.IOException;
import java.util.concurrent.CountDownLatch;

import com.sun.grizzly.Context;
import com.sun.grizzly.ProtocolFilter;
import com.sun.grizzly.ProtocolParser;

/**
 * @author kloh
 * 
 */
public class ClientForwardFilter implements ProtocolFilter {

	private CountDownLatch mCountDownLatch;
	
	public ClientForwardFilter(CountDownLatch pCountDownLatch) {
		this.mCountDownLatch = pCountDownLatch;
	}
	
	/*
	 * (non-Javadoc)
	 * 
	 * @see com.sun.grizzly.ProtocolFilter#execute(com.sun.grizzly.Context)
	 */
	public boolean execute(final Context pContext) throws IOException {

		final String lMessage = (String) pContext
				.removeAttribute(ProtocolParser.MESSAGE);

		// just print the message
		System.out.println(lMessage);

		// signal the clientthread, that the message is arrived
		this.mCountDownLatch.countDown();
		
		return false;

	}
	
	/*
	 * (non-Javadoc)
	 * 
	 * @see com.sun.grizzly.ProtocolFilter#postExecute(com.sun.grizzly.Context)
	 */
	public boolean postExecute(final Context ctx) throws IOException {
		return true;
	}

}
