package mailinglist.server;

import java.io.IOException;
import java.nio.ByteBuffer;
import java.nio.channels.SelectableChannel;
import java.util.UUID;

import com.sun.grizzly.Context;
import com.sun.grizzly.ProtocolFilter;
import com.sun.grizzly.ProtocolParser;
import com.sun.grizzly.util.OutputWriter;

/**
 * @author kloh
 * 
 */
public class ServerForwardFilter implements ProtocolFilter {

	/*
	 * (non-Javadoc)
	 * 
	 * @see com.sun.grizzly.ProtocolFilter#execute(com.sun.grizzly.Context)
	 */
	public boolean execute(final Context pContext) throws IOException {

		final String lMessage = (String) pContext
				.removeAttribute(ProtocolParser.MESSAGE);

		doSomethingWithMessage(lMessage, pContext.getSelectionKey().channel());

		return false;

	}

	private void doSomethingWithMessage(String pMessage, SelectableChannel pChannel) {

		// pretend to work...
		try {
			// 5 seconds are insufficient
			Thread.sleep(7500);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		
		String lMetadata = pMessage.substring(0, pMessage.indexOf(":") + 1).concat(" ");
		
		ByteBuffer lBuffer = ByteBuffer.allocateDirect(4 + lMetadata.getBytes().length + 10 * 36);
		lBuffer.putInt(lMetadata.getBytes().length + 10 * 36);
		lBuffer.put(lMetadata.getBytes());
		for (int i=0; i<10; i++)
			lBuffer.put(UUID.randomUUID().toString().getBytes());
		lBuffer.flip();
		
		try {
			OutputWriter.flushChannel(pChannel, lBuffer);
		} catch (IOException e) {
			e.printStackTrace();
		}

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see com.sun.grizzly.ProtocolFilter#postExecute(com.sun.grizzly.Context)
	 */
	public boolean postExecute(final Context ctx) throws IOException {
		return true;
	}

}
